class Ticker expands actor;

var float NowTime, OldTime, LastSpeakTime;
var int SpTime, Ticks, FRate;
var bool bDisabled;
var string ANote;

event PostBeginPlay()
{
	if ( Level.NetMode == NM_DedicatedServer )
	{
		log (Self$" > Initialization in next 2 seconds...");
		SetTimer(2.00,False);
	}
	else
	{
		log ( Self$" doesn't run in this environment. Expecting > Dedicated Server.");
		bDisabled = True;
		Disable ('Tick');
		return;
	}
}

event Timer()
{
	log ("Ignited TickSpy... Attempt to get Configured TickRate...");
	GetTickInterval();
}

function GetTickInterval()
{
	FRate = int(ConsoleCommand("GET XC_IPDRV.XC_TCPNETDRIVER NETSERVERMAXTICKRATE"));
	if ( FRate <= 0)
		FRate = int(ConsoleCommand("GET IPDRV.TCPNETDRIVER NETSERVERMAXTICKRATE"));
	if ( FRate <= 0 )
	{
		log (Self$" > Cannot retrieve TickRate");
		Disable('Tick');
		bDisabled=True;
		return;
	}
	if ( FRate > 0 )
	{
		Ticks = FRate;
		FRate = (1000*Level.TimeDilation)/FRate; // 1000ms/30
		log ( Self$" > Detected TickRate set at "$Ticks );
		log ( Self$" > Ideal Tick Interval has been computed at "$FRate );
	}
}

event Tick(float DT)
{
	if (!bDisabled)
	{
		NowTime = Level.TimeSeconds;
		if ( NowTime > OldTime )
		{
			SpTime = int((1000*Level.TimeDilation)/(( NowTime-OldTime )*(1000*Level.TimeDilation)));
//			log (SpTime);
			OldTime = Level.TimeSeconds;
		}
		if ( LastSpeakTime + 3 < Level.TimeSeconds )
		{
			if ( SpTime <= Ticks*0.8 )
			{
				ANote="Tick went at "$SpTime$" from "$Ticks$" per second.";
				BroadcastMessage( ANote,False,);
				log ("TickRate went "$SpTime);
			}
			LastSpeakTime = Level.TimeSeconds;
		}
	}
}

defaultproperties
{
   bHidden=True
   bAlwaystick=True
}